#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <pc.h>

int port, romsize;
char *filename;
FILE *outfile;

void abort_(void) {
    delline();
    printf ("User abort.\n");
    fclose (outfile);
    remove (filename);
    getkey();
    outportb (port + 4, 3);
    exit(0);
    }

unsigned char getbit(void) {

    unsigned char b;

    for (;;) {
        b = inportb(port + 6) / 16 & 3;
        if (b == (inportb(port + 6) / 16 & 3)) break; /* slow down a fast PC */
    }
    return b;
}

unsigned char recvbyt(void) {

    unsigned char curbit = 1;
    unsigned char byt = 0, bits, x;

    for (bits = 1; bits <= 8; bits++) {
	while ((x = getbit()) == 3) if (kbhit()) abort_();
	if (x == 1) {
	    byt += curbit;
	    outportb(port + 4, 1);
	    x = 2;
      }	else {
	    outportb(port + 4, 2);
	    x = 1;
	}
	while ((getbit() & x) == 0) if (kbhit()) abort_();
	outportb(port + 4, 3);
	curbit <<= 1;
    }
    return byt;
}

void main(int argc, char *argv[]) {

    int n, p1, p2, k1, k2;

    port = 0x3f8;
    romsize = 131072;
    filename = "ti8x.rom";

    printf ("getrom8x v0.11 by Owen Evans (richardwevans@worldnet.att.net)\n\n");

    for (n = 1; n < argc; n++) {
        strlwr(argv[n]);
        if (argv[n][0] == '/' || argv[n][0] == '-') {
            if (argv[n][1] == 'p') {
                if (argv[n][2] == '1') port = 0x3f8;
                else if (argv[n][2] == '2') port = 0x2f8;
                else if (argv[n][2] == '3') port = 0x3e8;
                else if (argv[n][2] == '4') port = 0x2e8;
          } else if (argv[n][1] == '8') {
                if (argv[n][2] == '2' || argv[n][2] == '5') romsize = 131072;
                else if (argv[n][2] == '3' || argv[n][2] == '6') romsize = 262144;
          } else if (argv[n][1] == '?') {
                printf ("  Usage:\n"
                        "    getrom8x [-p<port>] [-<calc>] <filename>\n\n"
                        "  Syntax:\n"
                        "    -p<port>   Defines which com port the link is on.\n"
                        "                 values: 1, 2, 3, 4.  default: 1.\n"
                        "    -<calc>    Defines what type of calculator to recieve rom from.\n"
                        "                 values: 82, 83, 85, 86.  default: 82\n"
                        "    <filename> Name of file to dump the rom into.\n"
                        "                 default: ti8x.rom\n");
                return; 
            }
      } else filename = argv[n];
    }

    if (!(outfile = fopen(filename, "wb"))) {
        printf ("Invalid filename: %s\n", filename);
        return;
    }

    if (argc == 1) printf("No options specified, using defaults.  Run getrom8x /? to see options.\n");

    printf ("Romsize: %d.\n", romsize);
    printf ("Port: %x.\n", port);
    printf ("Filename: %s.\n\n", filename);

    outportb (port + 4, 3);

    printf ("Press any key to abort . . .\n");

    for (n = 0; n < romsize; n++) {
        fputc (recvbyt(), outfile);

        p1 = ((n * 100) / romsize);
        k1 = (n / 1024);


        if (p1 != p2 || k1 != k2) {
             printf ("%dk/%dk (%d%%) recieved\n", k1, romsize / 1024, p1);
             gotoxy (wherex(), wherey() - 1);
        }

        p2 = p1;
        k2 = k1;

        if (kbhit()) abort_();

    }

    printf ("Rom recieved successfully.\n");
    fclose (outfile);

    return;
}


